package hospital.actors;

import hospital.actors.gui.PlainSenderGUI;
import net.ponder2.ManagedObject;
import net.ponder2.Util;
import net.ponder2.apt.Ponder2op;
import net.ponder2.exception.Ponder2AuthorizationException;
import net.ponder2.exception.Ponder2Exception;
import net.ponder2.exception.Ponder2ResolveException;
import net.ponder2.objects.P2Object;

public class ResearcherMO implements ManagedObject {
	
	protected P2Object  myP2Object;
	protected String name, myPath;
	protected PlainSenderGUI myGUI;
	
	@Ponder2op("create:path:")
	public ResearcherMO(P2Object myP2Object, String name, String myPath) {
		super();
		this.myP2Object = myP2Object;
		this.name = name;
		this.myPath = myPath;
		 myGUI= new PlainSenderGUI("Patient");
		 myGUI.start(this, myPath);
	}

	public String checkData(String patientPath) {
	  P2Object patientOID = null;
	  P2Object patientRecord = null;
		try {
			patientOID = Util.resolve(patientPath);
			patientRecord = patientOID.operation(myP2Object, "getdata", P2Object.create(name));
		}catch (Ponder2AuthorizationException e) {
			System.out.println("ResearcherMO.checkdata(): A Ponder2AuthorizationException OCCURED!!!!");
			System.out.println("ResearcherMO.checkdata(): This researcher does not have the permission of access the patient data.");
			return " A Ponder2AuthorizationException OCCURED! This researcher does not have the permission of access the patient data.";
		}catch (Ponder2ResolveException e) {
			System.out.println("ResearcherMO.checkdata(): A Ponder2ResolveException OCCURED!!!!");
			return "A Ponder2ResolveException occured. Please make sure that the correct path to the patient is specified.";
		} catch (Ponder2Exception e) {
			System.out.println("ResearcherMO.checkdata(): A Ponder2Exception OCCURED!!!!");
			e.printStackTrace();
			return "A Ponder2Exception OCCURED!!!!";
		}
		return "The patient data is " + patientRecord.toString();
	}

	public String getResearcherPath() {
		// TODO Auto-generated method stub
		return myPath;
	}
	
	
	

}
