package hospital.actors.gui;

/*
 * TextSamplerDemo.java requires the following files:
 *   TextSamplerDemoHelp.html (which references images/dukeWaveRed.gif)
 *   images/Pig.gif
 *   images/sound.gif
 */

import hospital.actors.NurseMO;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.NumberFormat;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;

import net.ponder2.ManagedObject;

public class ADVSenderGUI extends JPanel
                             implements ActionListener {
    private String newline = "\n";
    
    protected static final String buttonString = "OK";
    JFormattedTextField senderProperty;
    JTextField receiverField;
    JTextArea textArea;
    ManagedObject sender;

    protected JLabel actionLabel;

     public ADVSenderGUI(String senderType, 
    		 			 String receiverType, 
    		 			 String receiverPathDefault,
    		 			 String senderPrpLabel) {

        setLayout(new BorderLayout());

        //Create a regular text field.
        receiverField = new JTextField(receiverPathDefault, 10);
        
        receiverField .setActionCommand(receiverType + " Path");
        receiverField .addActionListener(this);
        


        //Create a password field.
/*        JPasswordField passwordField = new JPasswordField(10);
        passwordField.setActionCommand(passwordFieldString);
        passwordField.addActionListener(this);*/

        //Create a formatted text field.
         senderProperty= new JFormattedTextField(NumberFormat.getIntegerInstance());
        senderProperty.setActionCommand(receiverType+ " Path");
        senderProperty.addActionListener(this);

        //Create some labels for the fields.
        JLabel textFieldLabel = new JLabel(receiverType+ " Path" + ": ");
        textFieldLabel.setLabelFor(receiverField);
        //JLabel passwordFieldLabel = new JLabel(passwordFieldString + ": ");
       // passwordFieldLabel.setLabelFor(passwordField);
        JLabel ftfLabel = new JLabel(senderType + " "+ senderPrpLabel + ": ");
        ftfLabel.setLabelFor(senderProperty);

        //Create a label to put messages during an action event.
        actionLabel = new JLabel("Type " +receiverType+ " Path and " + senderType+ " " + senderPrpLabel +" and then press the OK button.");
        actionLabel.setBorder(BorderFactory.createEmptyBorder(10,0,0,0));
        
                
        // Create the button
        JButton button = new JButton();
        button.setText(buttonString);
        button.setActionCommand(buttonString);
        button.addActionListener(this);


        //Lay out the text controls and the labels.
        JPanel textControlsPane = new JPanel();
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        textControlsPane.setLayout(gridbag);

        JLabel[] labels = {textFieldLabel,  ftfLabel};
        JTextField[] textFields = {receiverField , senderProperty};
        addLabelTextRows(labels, textFields, gridbag, textControlsPane);

        c.gridwidth = GridBagConstraints.REMAINDER; //last
        c.anchor = GridBagConstraints.WEST;
        c.weightx = 1.0;
        textControlsPane.add(actionLabel, c);
        textControlsPane.setBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Input Fields"),
                                BorderFactory.createEmptyBorder(5,5,5,5)));
        
        c.anchor = GridBagConstraints.EAST;
        c.weightx = 1.0;
        textControlsPane.add(button, c);

        //Create a text area.
        textArea = new JTextArea();
        textArea.setFont(new Font("Serif", Font.PLAIN, 16));
        textArea.setEditable(false);
        textArea.setLineWrap(true);
        textArea.setWrapStyleWord(true);
        JScrollPane areaScrollPane = new JScrollPane(textArea);
        areaScrollPane.setVerticalScrollBarPolicy(
                        ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        areaScrollPane.setPreferredSize(new Dimension(500, 500));
        areaScrollPane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder(senderType + " Output"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                areaScrollPane.getBorder()));



        //Create a text pane.
/*        JTextPane textPane = createTextPane();
        JScrollPane paneScrollPane = new JScrollPane(textPane);
        paneScrollPane.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        paneScrollPane.setPreferredSize(new Dimension(400, 300));
        paneScrollPane.setMinimumSize(new Dimension(10, 10));*/

        //Put the editor pane and the text pane in a split pane.
/*        JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                                              editorScrollPane,
                                              paneScrollPane);
        splitPane.setOneTouchExpandable(true);
        splitPane.setResizeWeight(0.5);
        JPanel rightPane = new JPanel(new GridLayout(1,0));
        rightPane.add(splitPane);
        rightPane.setBorder(BorderFactory.createCompoundBorder(
                        BorderFactory.createTitledBorder("Styled Text"),
                        BorderFactory.createEmptyBorder(5,5,5,5)));*/


        //Put everything together.
        //JPanel leftPane = new JPanel(new BorderLayout());
        //leftPane.
        add(textControlsPane, BorderLayout.PAGE_START);
        //leftPane.
        add(areaScrollPane,
                     BorderLayout.CENTER);

        //add(leftPane, BorderLayout.LINE_START);
       /* add(rightPane, BorderLayout.LINE_END);*/
    }

    private void addLabelTextRows(JLabel[] labels,
                                  JTextField[] textFields,
                                   GridBagLayout gridbag,
                                  Container container) {
        GridBagConstraints c = new GridBagConstraints();
        c.anchor = GridBagConstraints.EAST;
        int numLabels = labels.length;

        for (int i = 0; i < numLabels; i++) {
            c.gridwidth = GridBagConstraints.RELATIVE; //next-to-last
            c.fill = GridBagConstraints.NONE;      //reset to default
            c.weightx = 0.0;                       //reset to default
            container.add(labels[i], c);

            c.gridwidth = GridBagConstraints.REMAINDER;     //end row
            c.fill = GridBagConstraints.HORIZONTAL;
            c.weightx = 1.0;
            container.add(textFields[i], c);
        }

    }

    public void actionPerformed(ActionEvent e) {
        //String prefix = "You typed \"";
/*        JTextField source = (JTextField)e.getSource();
        actionLabel.setText(prefix + source.getText() + "\"");*/
/*        if (patientNameString.equals(e.getActionCommand())) {
        	getInput();

        }  else if {
        } else*/ if (buttonString.equals(e.getActionCommand())) {

            getInput();
        }
    }


    //customize this method for the specific sender
    private void getInput() {
		
    	String patientPath = this.receiverField.getText();
    	String slevel = this.senderProperty.getText();
    	int level;
    	if(slevel.equals("")) {
    		level = ((NurseMO)sender).getNurseLevel();
    	}  
    	else level = Integer.parseInt(slevel);
    	
    	this.textArea.append("Going to retrieve the record for patient "+patientPath+newline);
  
    	this.textArea.append("The level of this nurse is set to "+level+newline); 	
		
    	output(((NurseMO)sender).checkRecord(patientPath, level)+" "+newline);
	}
    
    private void output(String s){
    	this.textArea.append(s);
    }

//	private JTextPane createTextPane() {
//
//
//        JTextPane textPane = new JTextPane();
//       
//
//        return textPane;
//    }





    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     * @param patient 
     */
    private void createAndShowGUI(ManagedObject sender, String senderPath) {
    	this.sender=sender;
        //Create and set up the window.
        JFrame frame = new JFrame(senderPath);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        
       this.setOpaque(true); //content panes must be opaque
        frame.setContentPane(this);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public void start(final ManagedObject sender, final String senderPath) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI(sender, senderPath);
            }
        });
    }
    

}
