package hospital.actors.gui;

/*
 * TextSamplerDemo.java requires the following files:
 *   TextSamplerDemoHelp.html (which references images/dukeWaveRed.gif)
 *   images/Pig.gif
 *   images/sound.gif
 */

import hospital.actors.ResearcherMO;

import javax.swing.*;

import net.ponder2.ManagedObject;



import java.awt.*;              //for layout managers and more
import java.awt.event.*;        //for action events

public class PlainSenderGUI extends JPanel
                             implements ActionListener {
    private String newline = "\n";
    
    protected String buttonString = "OK";
    JTextField recevierField;
    JTextArea textArea;
    ManagedObject sender;

    protected JLabel actionLabel;

    /**
     * 
     */
     public PlainSenderGUI(String receiverType) {

        setLayout(new BorderLayout());

        //Create a regular text field.
        recevierField = new JTextField(10);
        recevierField .setActionCommand(receiverType + " Path");
        recevierField .addActionListener(this);
        


        //Create a password field.
/*        JPasswordField passwordField = new JPasswordField(10);
        passwordField.setActionCommand(passwordFieldString);
        passwordField.addActionListener(this);*/
      

        //Create some labels for the fields.
        JLabel textFieldLabel = new JLabel(receiverType + " Path: ");
        textFieldLabel.setLabelFor(recevierField);
        //JLabel passwordFieldLabel = new JLabel(passwordFieldString + ": ");
       // passwordFieldLabel.setLabelFor(passwordField);
       

        //Create a label to put messages during an action event.
        actionLabel = new JLabel("Type Patient Path and then press the OK button.");
        actionLabel.setBorder(BorderFactory.createEmptyBorder(10,0,0,0));
        
                
        // Create the button
        JButton button = new JButton();
        button.setText(buttonString);
        button.setActionCommand(buttonString);
        button.addActionListener(this);


        //Lay out the text controls and the labels.
        JPanel textControlsPane = new JPanel();
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        textControlsPane.setLayout(gridbag);

        JLabel[] labels = {textFieldLabel};
        JTextField[] textFields = {recevierField};
        addLabelTextRows(labels, textFields, gridbag, textControlsPane);

        c.gridwidth = GridBagConstraints.REMAINDER; //last
        c.anchor = GridBagConstraints.WEST;
        c.weightx = 1.0;
        textControlsPane.add(actionLabel, c);
        textControlsPane.setBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Input Fields"),
                                BorderFactory.createEmptyBorder(5,5,5,5)));
        
        c.anchor = GridBagConstraints.EAST;
        c.weightx = 1.0;
        textControlsPane.add(button, c);

        //Create a text area.
        textArea = new JTextArea();
        textArea.setFont(new Font("Serif", Font.PLAIN, 16));
        textArea.setEditable(false);
        textArea.setLineWrap(true);
        textArea.setWrapStyleWord(true);
        JScrollPane areaScrollPane = new JScrollPane(textArea);
        areaScrollPane.setVerticalScrollBarPolicy(
                        ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        areaScrollPane.setPreferredSize(new Dimension(500, 500));
        areaScrollPane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Researcher Output"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                areaScrollPane.getBorder()));



        


        //Put everything together.
        //JPanel leftPane = new JPanel(new BorderLayout());
        //leftPane.
        add(textControlsPane, BorderLayout.PAGE_START);
        //leftPane.
        add(areaScrollPane,
                     BorderLayout.CENTER);

        //add(leftPane, BorderLayout.LINE_START);
       /* add(rightPane, BorderLayout.LINE_END);*/
    }

    private void addLabelTextRows(JLabel[] labels,
                                  JTextField[] textFields,
                                   GridBagLayout gridbag,
                                  Container container) {
        GridBagConstraints c = new GridBagConstraints();
        c.anchor = GridBagConstraints.EAST;
        int numLabels = labels.length;

        for (int i = 0; i < numLabels; i++) {
            c.gridwidth = GridBagConstraints.RELATIVE; //next-to-last
            c.fill = GridBagConstraints.NONE;      //reset to default
            c.weightx = 0.0;                       //reset to default
            container.add(labels[i], c);

            c.gridwidth = GridBagConstraints.REMAINDER;     //end row
            c.fill = GridBagConstraints.HORIZONTAL;
            c.weightx = 1.0;
            container.add(textFields[i], c);
        }

    }

    public void actionPerformed(ActionEvent e) {
        //String prefix = "You typed \"";
/*        JTextField source = (JTextField)e.getSource();
        actionLabel.setText(prefix + source.getText() + "\"");*/
/*        if (patientNameString.equals(e.getActionCommand())) {
        	getInput();

        }  else if {
        } else*/ if (buttonString.equals(e.getActionCommand())) {

            getInput();
        }
    }


    //customize this method for the specific sender
    private void getInput() {
		
    	String receiverPath = this.recevierField.getText();
    	    	
    	this.textArea.append("Going to retrieve the data for patient "+receiverPath+newline);
      	
    	output(((ResearcherMO)sender).checkData(receiverPath)+newline);
	}
    
    private void output(String s){
    	this.textArea.append(s);
    }

//	private JTextPane createTextPane() {
//
//
//        JTextPane textPane = new JTextPane();
//       
//
//        return textPane;
//    }





    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     * @param patient 
     */
    private void createAndShowGUI(ManagedObject sender, String senderPath) {
    	this.sender= sender;
        //Create and set up the window.
        JFrame frame = new JFrame(senderPath);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        
       this.setOpaque(true); //content panes must be opaque
        frame.setContentPane(this);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public void start(final ManagedObject  sender, final String senderPath) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI(sender, senderPath );
            }
        });
    }
    

}
