package unidep.actors;

import unidep.actors.gui.ReceiverGUI;
import net.ponder2.ManagedObject;
import net.ponder2.apt.Ponder2op;
import net.ponder2.objects.P2Object;

public class PrinterMO implements ManagedObject {

	protected String name, specs, myPath;
	protected P2Object myP2Object;
	protected ReceiverGUI myGUI;
	
	
	@Ponder2op("createname:spec:path:")
	public PrinterMO(P2Object myP2Object, String name, String specs, String myPath) {
		super();
		this.myP2Object = myP2Object;
		this.name = name;
		this.specs = specs;
		this.myPath = myPath;
		myGUI = new ReceiverGUI("Printer", "Name", "Spec", null, name, specs, null);
	    myGUI.start(this, this.myPath);
	}
	
	
	@Ponder2op("clrprint:")
	public void colorPrint(String docName){
		
		System.out.println("PrinterMO.colorPrint(): going to print document " + docName);
		myGUI.output("Color print of document " + docName);
	}
	
	@Ponder2op("bwprint:")
	public void bwPrint(String docName){
		System.out.println("PrinterMO.bwPrint(): going to print document " + docName);
		myGUI.output("BW print of document " + docName);
	}
}
