package unidep.actors;

import unidep.actors.gui.ADVSenderGUI;
import net.ponder2.ManagedObject;
import net.ponder2.Util;
import net.ponder2.apt.Ponder2op;
import net.ponder2.exception.Ponder2AuthorizationException;
import net.ponder2.exception.Ponder2Exception;
import net.ponder2.exception.Ponder2ResolveException;
import net.ponder2.objects.P2Object;

public class StudentMO implements ManagedObject {
	
	protected P2Object myP2Object;
	protected String name, myPath;
	
	protected ADVSenderGUI myGUI;

	@Ponder2op("createname:path:")
	public StudentMO(P2Object myP2Object, String name, String myPath) {
		super();
		this.myP2Object = myP2Object;
		this.name = name;
		this.myPath = myPath;
		myGUI = new ADVSenderGUI("Student", "Printer", "/ptr/clr/hue", "PrintType" );
		myGUI.start(this, this.myPath);
	}
	
	
	public String sendPrintJob(String printerPath, String docName, String printType) {
		  P2Object printerOID = null;
		  P2Object reply = null;
			try {
				printerOID = Util.resolve(printerPath);
				if("BW".equals(printType))
					reply = printerOID.operation(myP2Object, "bwprint:", P2Object.create(docName));
				else if("C".equals(printType))
					reply = printerOID.operation(myP2Object, "clrprint:", P2Object.create(docName));
				else{
					System.out.println("StudentMO.sendPrintJob(): " +printType + " is an unknown print type. Valid values are C or BW");
					return printType + " is an unknown print type. Valid values are C or BW";
				}
			}catch (Ponder2AuthorizationException e) {
				System.out.println("StudentMO.sendPrintJob(): A Ponder2AuthorizationException OCCURED!!!!");
				System.out.println("StudentMO.sendPrintJob(): This stundent does not have the permission for sending a print job.");
				return " A Ponder2AuthorizationException OCCURED! This student does not have the permission for sending a print job.";
			}catch (Ponder2ResolveException e) {
				System.out.println("StudentMO.sendPrintJob(): A Ponder2ResolveException OCCURED!!!!");
				return "A Ponder2ResolveException occured. Please make sure that the correct path to the printer is specified.";
			} catch (Ponder2Exception e) {
				System.out.println("StudentMO.sendPrintJob(): A Ponder2Exception OCCURED!!!!");
				e.printStackTrace();
				return "A Ponder2Exception OCCURED!!!!";
			}
			return "The print job was successfully submitted." ;
		}

	

}
