package unidep.actors.gui;

/*
 * TextSamplerDemo.java requires the following files:
 *   TextSamplerDemoHelp.html (which references images/dukeWaveRed.gif)
 *   images/Pig.gif
 *   images/sound.gif
 */

import javax.swing.*;

import net.ponder2.ManagedObject;


import java.awt.*;              //for layout managers and more

public class ReceiverGUI extends JPanel {
                             
    private String newline = "\n";
    
     
    JTextArea textArea;
    ManagedObject recevierMO;

    protected JLabel actionLabel;

      public ReceiverGUI(String receiverType, 
    		  			 String nameLabelStr, 
    		  			 String detail1LabelString, 
      					 String detail2LabelString,	
    		  			 String receiverName, String detail1Value, String detail2Value) {

        setLayout(new BorderLayout());
        
        //create the patient details panel
        JLabel nameLabel = new JLabel(receiverType +" "+nameLabelStr +": "  +receiverName);
        JLabel detail1Label =null;
        JLabel detail2Label = null;
        
        if(detail1LabelString != null)
        	detail1Label = new JLabel(receiverType +" "+detail1LabelString+": " + detail1Value);
        if(detail2LabelString != null)
        	detail2Label = new JLabel(receiverType +" "+detail2LabelString + ": " + detail2Value);
        
        JPanel receiverDetailsPanel = new JPanel();
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        receiverDetailsPanel.setLayout(gridbag);

        

        c.gridwidth = GridBagConstraints.REMAINDER; //last
        c.anchor = GridBagConstraints.WEST;
        c.weightx = 1.0;
        receiverDetailsPanel.add(nameLabel, c);
        if(detail1Label != null)
        	receiverDetailsPanel.add(detail1Label,c);
        if(detail2Label != null)
        	receiverDetailsPanel.add(detail2Label,c);
        receiverDetailsPanel.setBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder(receiverType + " Details"),
                                BorderFactory.createEmptyBorder(5,5,5,5)));
        
        c.anchor = GridBagConstraints.EAST;
        c.weightx = 1.0;
        
        
        //Create a text area.
        textArea = new JTextArea();
        textArea.setFont(new Font("Serif", Font.PLAIN, 16));
        textArea.setEditable(false);
        textArea.setLineWrap(true);
        textArea.setWrapStyleWord(true);
        JScrollPane areaScrollPane = new JScrollPane(textArea);
        areaScrollPane.setVerticalScrollBarPolicy(
                        ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        areaScrollPane.setPreferredSize(new Dimension(500, 500));
        areaScrollPane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder( receiverType + " Output"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                areaScrollPane.getBorder()));



        //Create a text pane.
/*        JTextPane textPane = createTextPane();
        JScrollPane paneScrollPane = new JScrollPane(textPane);
        paneScrollPane.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        paneScrollPane.setPreferredSize(new Dimension(400, 300));
        paneScrollPane.setMinimumSize(new Dimension(10, 10));*/

        //Put the editor pane and the text pane in a split pane.
/*        JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                                              editorScrollPane,
                                              paneScrollPane);
        splitPane.setOneTouchExpandable(true);
        splitPane.setResizeWeight(0.5);
        JPanel rightPane = new JPanel(new GridLayout(1,0));
        rightPane.add(splitPane);
        rightPane.setBorder(BorderFactory.createCompoundBorder(
                        BorderFactory.createTitledBorder("Styled Text"),
                        BorderFactory.createEmptyBorder(5,5,5,5)));*/

        add(receiverDetailsPanel, BorderLayout.PAGE_START);
     
        add(areaScrollPane,
                     BorderLayout.CENTER);

        //add(leftPane, BorderLayout.LINE_START);
       /* add(rightPane, BorderLayout.LINE_END);*/
    }

    

    



    
    
    public void output(String s){
    	this.textArea.append(s+newline);
    }

//	private JTextPane createTextPane() {
//
//
//        JTextPane textPane = new JTextPane();
//       
//
//        return textPane;
//    }





    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     * @param recevierMO 
     */
    private void createAndShowGUI(ManagedObject recevier, String receiverPath) {
    	this.recevierMO=recevier;
        //Create and set up the window.
        JFrame frame = new JFrame(receiverPath);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        
       this.setOpaque(true); //content panes must be opaque
        frame.setContentPane(this);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public void start(final ManagedObject recevier, final String receiverPath) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI(recevier, receiverPath);
            }
        });
    }
    

}
